#ifndef MODEL_INCLUDED
#define MODEL_INCLUDED
#include <quadpack.h>
#include <oxdraw.h>
#import "maximize"

class Model{
		decl 	Wmin,		//	Mandatory minimum wage
				B, 			//	Reservation wages
				M,			// 	Household distribution
				Lambda,		//	Job offer arrival rate
				Delta,		//	Job separation rate
				Kappa, 		//	Lambda ./ Delta
				Mu1,		//	Mean of lower distribution
				Mu2,		//	Mean of upper distribution
				Sigma,		//	Standard deviation
				Pie,		//	Percentage of total mass of lower distribution
				W,
				T;

		Model(const lambda, const delta, const mu1, const mu2,
					const sigma, const pie, const wmin, const b, const m);
		Dfie(const w);
		Fie(const w);
		Gie(const w);
		Berpur();
		Dgie(const w);
		Dpsig(const p);
		Psif1(const p);
		Psif11(const p);
		Psif2(const p);
		Psif3(const p);
		Psif(const p);
		Bers();
		Berf();
		Psifie(const p, const t);
		Psifieb(const p, const t);
		Beru(const p);
		Dponder(const w);
		Psiu(const p);
		Puu();
		Pboven(const w);
		Ponder(const w);
		Psig(const p);
		Jie(const p);
		Jie1(const p);
		Jie2(const p);
		Jie3(const p);
		Cumj(const p);
		Cumj1(const p);
		Cumj2(const p);
		Cumj3(const p);
		Dpsi(const p);
		Psi(const p);
		Denf(const w, const p);
		Deng(const w, const p);
		Cumf(const w, const p);
		Cumg(const w, const p);
		Deng1(const w, const p);
		Denf1(const w, const p);
		Cumf1(const w,const p);
		Cumg1(const w,const p);
		Denf11(const w, const p, const wmin);
		Denf11a(const w, const p, const wmin);
		Denf11b(const w, const p, const wmin);
		Denf12(const w, const p,const wmin);
		Denf13(const w, const p,const wmin);
		Deng11(const w, const p, const wmin);
		Deng11a(const w, const p, const wmin);
		Deng11b(const w, const p, const wmin);
		Deng12(const w, const p,const wmin);
		Deng13(const w, const p,const wmin);
		Cumf11(const w, const p, const wmin);
		Cumf11a(const w, const p, const wmin);
		Cumf11b(const w, const p, const wmin);
		Cumf12(const w, const p,const wmin);
		Cumf13(const w, const p,const wmin);
		Cumg11(const w, const p, const wmin);
		Cumg11a(const w, const p, const wmin);
		Cumg11b(const w, const p, const wmin);
		Cumg12(const w, const p,const wmin);
		Cumg13(const w, const p,const wmin);
		Psit(const t);
		Psit1(const t);
		Psit1a(const p);
		Psit2a(const p);
		Psit3a(const p);
		Psit11a(const p);
		Ponder1(const vP, const adFunc, const avScore, const mHess);
		Beralpha();
		GetLambda();
		GetDelta();
		GetPie();
		GetSigma();
		GetMu1();
		GetMu2();
		ModifyLambda(const lambda);
		ModifyDelta(const delta);
		ModifyPie(const pie);
		ModifySigma(const sigma);
		ModifyMu1(const mu1);
		ModifyMu2(const mu2);
}
